/**
 * sd.admin.js
 *
 * @author SaurabhSharma
 * @version 1.0.0
 */
jQuery(function ($) {

    'use strict';

    // Generate table for scripts
    function sd_scripts_table() {
        var tr = $('table#sd-scripts-table tr:not(:nth-child(1))'),
            dq_li = $('#sd-scripts-for-dequeue > li:not(.no-script)'),
            dq_val = $('#sdequeuer_options\\[sd_scripts_selected\\]'),
            dq_wrap = $('#sc-dequeue-wrap'),
            dqed_ul = $('#sd-scripts-dequeued'),
            dqed_wrap = $('#sc-dequeued-wrap'),
            failed_ul = $('#sd-scripts-not-dequeued'),
            failed_wrap = $('#sc-notdequeued-wrap'),
            sel_all_tr = $('#select-all-scripts'),
            sel_all_dqed = $('#select-dq-scripts'),
            dq_count = $('#script-dequeue-count'),
            dqed_count = $('#script-dequeued-count'),
            failed_count = $('#script-notdequeued-count');

        selectable_table(tr, dq_li, dq_val, dq_wrap, dqed_ul, dqed_wrap, failed_ul, failed_wrap, sel_all_tr, sel_all_dqed, dq_count, dqed_count, failed_count);
    }

    // Generate table for stylesheets
    function sd_styles_table() {
        var tr = $('table#sd-styles-table tr:not(:nth-child(1))'),
            dq_li = $('#sd-styles-for-dequeue > li:not(.no-script)'),
            dq_val = $('#sdequeuer_options\\[sd_styles_selected\\]'),
            dq_wrap = $('#st-dequeue-wrap'),
            dqed_ul = $('#sd-styles-dequeued'),
            dqed_wrap = $('#st-dequeued-wrap'),
            failed_ul = $('#sd-styles-not-dequeued'),
            failed_wrap = $('#st-notdequeued-wrap'),
            sel_all_tr = $('#select-all-styles'),
            sel_all_dqed = $('#select-dq-styles'),
            dq_count = $('#style-dequeue-count'),
            dqed_count = $('#style-dequeued-count'),
            failed_count = $('#style-notdequeued-count');

        selectable_table(tr, dq_li, dq_val, dq_wrap, dqed_ul, dqed_wrap, failed_ul, failed_wrap, sel_all_tr, sel_all_dqed, dq_count, dqed_count, failed_count);
    }

    $(document).on('table-updated', function () {
        sd_scripts_table();
        sd_styles_table();
    });


    // Creates table with selectable rows
    function selectable_table(tr, dq_li, dq_val, dq_wrap, dqed_ul, dqed_wrap, failed_ul, failed_wrap, sel_all_tr, sel_all_dqed, dq_count, dqed_count, failed_count) {
        var sc_arr = [],
            sc_final = [],
            sc_dq_arr_tmp = [],
            sc_dq_arr = [],
            sc_failed,
            sc_failed_li = '',
            sc_success,
            sc_success_li = '',
            tog1 = 0,
            tog2 = 0,
            sc_tmp_arr = [],
            sc_dq_final = [],
            sc_final_selected = [];

        // Store detected files
        if (tr.length) {
            tr.each(function () {
                if ($(this).data('handle')) {
                    sc_arr.push($(this).data('handle'));
                }
            });
        }

        // Show list of files added to dequeue
        if (dq_li.length) {
            dq_li.each(function () {
                sc_dq_arr_tmp.push($(this).data('handle'));
            });

            // Remove duplicates
            $.each(sc_dq_arr_tmp, function (i, el) {
                if ($.inArray(el, sc_dq_arr) === -1) sc_dq_arr.push(el);
            });

            $(dq_wrap).fadeIn();
        }

        // Find files which were not dequeued
        sc_failed = $.grep(sc_arr, function (i) {
            return $.inArray(i, sc_dq_arr) != -1;
        });

        // Find files which were dequeued successfully
        sc_success = $.grep(sc_dq_arr, function (i) {
            return $.inArray(i, sc_failed) == -1;
        });

        // Show successfully dequeued files list
        if (sc_success.length) {
            $(sc_success).each(function () {
                sc_success_li += '<li data-handle="' + this + '">' + this + '</li>';
            });
            $(dqed_ul).html(sc_success_li);
            $(dqed_wrap).fadeIn();
        }

        // Show failed files list
        if (sc_failed.length) {
            $(sc_failed).each(function () {
                sc_failed_li += '<li data-handle="' + this + '">' + this + '</li>';
            });
            $(failed_ul).html(sc_failed_li);
            $(failed_wrap).fadeIn();
        }

        // Store dequeue list for use in php
        if ($(dq_val).val()) {
            sc_dq_final = $.parseJSON($(dq_val).val());
        }

        // Selectable rows
        if (tr.length) {
            $(tr).each(function () {
                var handle = $(this).data('handle');
                $(this).removeClass('tr-error');
                if ($.inArray(handle, sc_failed) !== -1) {
                    $(this).addClass('tr-error');
                }
            });

            $(tr).on('click', function () {
                var handle = $(this).data('handle');

                // Enable selection only if the file is not in failed files list
                if ($.inArray(handle, sc_failed) === -1) {
                    $(this).toggleClass('tr-selected');
                }

                $(document).trigger('scripts-table-changed');
            });

        } // tr.length

        $(dq_li).on('click', function (e) {
            e.preventDefault();
            $(this).toggleClass('tr-selected');
            $(document).trigger('sc-dq-list-changed');
        });

        // Selectable exclude pages/posts list	
        $(dq_li).each(function () {
            var exclude_li = $(this).find('.sd-tabbed-content.sd-submenu > li'),
                postids = $(this).data('postids').split(','),
                pageids = $(this).data('pageids').split(',');

            $(exclude_li).on('click', function (e) {
                var postid = $(this).data('postid'),
                    pageid = $(this).data('pageid');

                e.preventDefault();

                $(this).toggleClass('ex-selected');

                if ($(this).hasClass('ex-selected')) {
                    if (postid) {
                        postids.push(postid);
                    }
                    if (pageid) {
                        pageids.push(pageid);
                    }
                } else {
                    postids = $.grep(postids, function (value) {
                        return value != postid;
                    });

                    pageids = $.grep(pageids, function (value) {
                        return value != pageid;
                    });
                }

                $(this).parent().parent().parent().attr('data-postids', postids.join(','));
                $(this).parent().parent().parent().attr('data-pageids', pageids.join(','));

                $(document).trigger('sc-dq-list-changed');
            });
        });

        // Select all detected scripts
        $(sel_all_tr).on('click', function (e) {
            e.preventDefault();
            if (tog1 % 2 === 0) {
                $(tr).not('.tr-error, .table-head').addClass('tr-selected');
            } else {
                $(tr).not('.tr-error, .table-head').removeClass('tr-selected');
            }
            tog1++;

            $(document).trigger('scripts-table-changed');
        });

        // Select all dequeued scripts
        $(sel_all_dqed).on('click', function (e) {
            e.preventDefault();
            if (tog2 % 2 === 0) {
                $(dq_li).addClass('tr-selected');
            } else {
                $(dq_li).removeClass('tr-selected');
            }
            tog2++;

            $(document).trigger('sc-dq-list-changed');
        });


        // Generate final dequeue list after all kind of selection/deselection
        $(document).on('scripts-table-changed sc-dq-list-changed', function (e) {

            if (e.type == 'scripts-table-changed') {
                sc_final = [];
                if (tr.length) {
                    $(tr).each(function () {
                        var handle = $(this).data('handle');
                        if ($(this).hasClass('tr-selected')) {
                            //sc_final.push(handle);
                            sc_final.push({
                                handle: handle,
                                postids: '',
                                pageids: ''
                            });
                        } else {
                            sc_final = $.grep(sc_final, function (value) {
                                return value.handle != handle;
                            });
                        }
                    });
                }

            } else if (e.type == 'sc-dq-list-changed') {
                sc_dq_final = [];
                if (dq_li.length) {
                    $(dq_li).each(function () {
                        var handle = $(this).data('handle'),
                            postids = $(this).attr('data-postids'),
                            pageids = $(this).attr('data-pageids');


                        if ($(this).hasClass('tr-selected')) {

                            sc_dq_final = $.grep(sc_dq_final, function (value) {
                                return value.handle != handle;
                            });

                        } else {
                            sc_dq_final.push({
                                handle: handle,
                                postids: postids ? postids : '',
                                pageids: pageids ? pageids : ''
                            });
                        }
                    });
                }
            }

            sc_final_selected = [];

            sc_final_selected = $.merge($.merge([], sc_final), sc_dq_final);

            // Remove duplicates
            sc_tmp_arr.length = 0;
            $.each(sc_final_selected, function (i, el) {
                if ($.inArray(el, sc_tmp_arr) === -1) sc_tmp_arr.push(el);
            });

            // Store the list for use in php
            $(dq_val).val(JSON.stringify(sc_final_selected));
        });

        // Update counts
        $(dq_count).html(sc_dq_arr.length);
        $(dqed_count).html(sc_success.length);
        $(failed_count).html(sc_failed.length);
    }

    // Detect and generate files list from front end
    function generate_scripts_list() {
        var site_urls = sd_localize !== 'undefined' ? sd_localize.site_urls : '',
            url_arr = [],
            sc_data = [],
            st_data = [],
            i = 0;

        url_arr = $.map($.parseJSON(site_urls), function (value, index) {
            return [value];
        });

        if (url_arr.length) {
            recursive_ajax(sc_data, st_data, url_arr, i);
        }
    }

    // Ajax call which searches for scripts on provided URLs
    function recursive_ajax(sc_data, st_data, url_arr, i) {
        var curr_url = url_arr[i],
            sep = '';

        // Show which URL is currently searched
        $('.sd-loading-text').append('<br/>' + url_arr[i]);

        // Remove trailing slash from URL
        curr_url = curr_url.replace(/\/+$/, "");

        // Add appropriate separator for query arg
        sep = curr_url.indexOf('?') !== -1 ? "&" : "/?";
        curr_url = curr_url + sep + 'sdlist=true';

        $.ajax({
            url: curr_url,
            timeout: 30000,
            cache: false,
            crossDomain: true,
            success: function (response) {
                sc_data[i] = $(response).filter('input#sd-scripts-list').data('files');
                st_data[i] = $(response).filter('input#sd-styles-list').data('files');
                i++;
                if (i >= url_arr.length) {
                    render_data(sc_data, st_data);
                    return false;
                }
                if (url_arr[i] && i < url_arr.length) {
                    recursive_ajax(sc_data, st_data, url_arr, i);
                }
            },
            error: function (xhr) {
                i++;
                if (i >= url_arr.length) {
                    render_data(sc_data, st_data);
                    return false;
                }
                if (url_arr[i] && i < url_arr.length) {
                    recursive_ajax(sc_data, st_data, url_arr, i);
                }
            }
        });
    }

    // Generate table rows based on collected data
    function render_data(sc_data, st_data) {

        var c1 = 0,
            c2 = 0,
            sc_tr = '',
            st_tr = '',
            m = {},
            n = {},
            i,
            j;

        for (i = 0; i < sc_data.length; i = i + 2) {
            m = $.extend(m, sc_data[i], sc_data[i + 1]);
        }

        for (j = 0; j < st_data.length; j++) {
            n = $.extend(n, st_data[j], st_data[j + 1]);
        }

        $.each(m, function (index, elem) {
            var deps = [];
            $.each(elem.deps, function (i, e) {
                deps.push(e);
            });
            c1++;
            sc_tr += '<tr data-handle="' + elem.handle + '"><td>' + elem.handle + '</td><td>' + elem.src + '</td><td>' + deps.join(', ') + '</td></tr>';
        }); //each

        $.each(n, function (index, elem) {
            var deps = [];
            $.each(elem.deps, function (i, e) {
                deps.push(e);
            });
            c2++;
            st_tr += '<tr data-handle="' + elem.handle + '"><td>' + elem.handle + '</td><td>' + elem.src + '</td><td>' + deps.join(', ') + '</td></tr>';
        }); //each

        $('.file-table-wrap').show();
        $('#script-detected-count').html(c1);
        $('#style-detected-count').html(c2);

        $('#sd-scripts-table').append(sc_tr);
        $('#sd-styles-table').append(st_tr);

        if ($.isEmptyObject(m)) {
            $('#sc-file-table, #sc-loading-text, #sc-loading-spinner').remove();
            $('#sd-sc-error').show();
        } else {
            $('#sc-progress-info').slideUp();

        }

        if ($.isEmptyObject(n)) {
            $('#st-file-table, #st-loading-text, #st-loading-spinner').remove();
            $('#sd-st-error').show();
        } else {
            $('#st-progress-info').slideUp();
        }

        $(document).trigger('table-updated');
    }

    generate_scripts_list();

    // Sortable URL list in admin
    function sd_sortable_urls() {
        $('#sd_add_url').on('click', function () {
            var url = $('#sd_url_input').val(),
                li = '';

            $('.sd-url-error').hide();

            if ($.trim(url)) {
                if (/\b(http:\/\/|https:\/\/)/.test(url)) {
                    li = '<li><span class="sd-url-text">' + $.trim(url) + '</span><span class="sd-close-btn"></span></li>';
                    $('#sd_url_input').val('');
                } else {
                    $('.sd-url-error').show();
                }
            }
            $('#sd-sortable-list').append(li);
            $(document).trigger('sd-url-list-updated');
        });

        $('#sd-sortable-list').sortable({
            axis: "y",
            update: function (event, ui) {
                $(document).trigger('sd-url-list-updated');
            }
        });
    }

    sd_sortable_urls();

    // Update URL list for use in php
    function sd_update_urls() {
        var sd_urls = $('#sdequeuer_options\\[sd_urls_added\\]'),
            url_li = $('#sd-sortable-list > li'),
            url_arr = [];

        if (url_li.length) {
            $(url_li).each(function () {
                var u = $(this).find('span.sd-url-text').text();
                if ($.trim(u)) {
                    url_arr.push($.trim(u));
                }
            });
        }

        sd_urls.val(JSON.stringify(url_arr));
    }

    $(document).on('sd-url-list-updated', function () {
        sd_update_urls();
    });

    $('.sd-close-btn').on('click', function () {
        $(this).parent().remove();
        $(document).trigger('sd-url-list-updated');
    });

    // Settings tab navigation
    function sd_tabs() {
        $('.sd-tabs > li > a').on('click', function (e) {
            e.preventDefault();
            var clicked_group = $(this).attr('href');
            $(this).parent().parent().find('> li > a').removeClass('sd-tab-active');
            $(this).addClass('sd-tab-active').blur();
            $(this).parent().parent().parent().find('> .sd-tabbed-content').removeClass('first').hide();
            $(clicked_group).show();
        });
    }

    sd_tabs();

    $('.exclude-toggle').on('click', function (e) {
        e.preventDefault();
        $(this).parent().parent().find('.exclude-toggle').not($(this)).removeClass('rotate-180');
        $(this).toggleClass('rotate-180');
        $(this).parent().parent().find('.sd-tabber').not($(this).next()).slideUp('fast');
        $(this).next().slideToggle();
    });

}); //$