<?php
/**
 * Helper functions used in the plugin
 */

function sd_generate_files_list() {
	if ( ! is_admin() ) {
		global $wp_scripts, $wp_styles;

		if ( isset( $_GET['sdlist'] ) && $_GET['sdlist'] == 'true' ) {
			$sc_list = array();
			$st_list = array();
			$i = 0;
			foreach( $wp_scripts->groups as $handle=>$value ) :
				$obj = $wp_scripts->registered[ $handle ];
				$sc_list[] =  array( 'handle' => $handle, 'src' => $obj->src, 'deps' => $obj->deps );
				$i++;
			endforeach;
			$json = json_encode($sc_list, JSON_FORCE_OBJECT);
			echo '<input type="text" id="sd-scripts-list" data-files=\'' . $json . '\'>';

			$i = 0;

			foreach( $wp_styles->groups as $handle=>$value ) :
				$obj = $wp_styles->registered[ $handle ];
				$st_list[] =  array( 'handle' => $handle, 'src' => $obj->src, 'deps' => $obj->deps );
				$i++;
			endforeach;
			$json = json_encode($st_list, JSON_FORCE_OBJECT);
			echo '<input type="text" id="sd-styles-list" data-files=\'' . $json . '\'>';
		}
	}
}

add_action( 'wp_footer', 'sd_generate_files_list' );

function sd_get_urls() {
	// Find a single post and category for links
	$sd_posts = get_posts( array( 'posts_per_page' => 1 ) );
	$single_url = '';
	$cat_url = '';
	$url_arr = [];

	if ( isset( $sd_posts ) && ! empty ( $sd_posts ) ) {
		foreach ( $sd_posts as $post ) :
			setup_postdata( $post );
			$single_url = get_permalink( $post->ID );
			$cat_obj = get_the_category( $post->ID );
			if ( isset( $cat_obj ) ) {
				$id = $cat_obj[0]->term_id;
				$cat_url = get_category_link( $id );
			}
		endforeach;
		wp_reset_postdata();
	}

	$url_arr[] = esc_url( rtrim( get_home_url(), "/" ) );
	if ( ! empty ( $single_url )  ) {
		$url_arr[] = esc_url( rtrim( $single_url, "/" ) );
	}
	if ( ! empty ( $cat_url )  ) {
		$url_arr[] = esc_url( rtrim( $cat_url, "/" ) );
	}

	return $url_arr;
}