<?php
/**
 * Scripts Dequeuer Settings
 *
 */

class Script_Dequeuer_Settings {

	function __construct() {
		add_action( 'admin_menu', array( $this, 'add_plugin_settings_menu' ) );
		add_action( 'admin_init', array( $this, 'register_settings' ) );
	}

	function add_plugin_settings_menu() {
		// add_options_page( $page_title, $menu_title, $capability, $menu_slug, $function )
		add_options_page( 'Scripts Dequeuer', 'Scripts Dequeuer', 'manage_options', 'scripts-dequeuer', array($this, 'sd_create_plugin_settings_page') );
	}

	function sd_create_plugin_settings_page() {
	?>
        <div class="wrap">

            <form method="post" action="options.php">
                <?php
                // Output all hidden fields
				settings_fields( 'sdequeuer-settings-group' );
                ?>

                <div class="wrap">
                    <h1 class="sd-settings-title"><?php esc_attr_e( 'Scripts Dequeuer Settings', 'sdequeuer' ); ?></h1>

                    <?php
                    $sd_options 				= get_option( 'sdequeuer_options' );
                    $sd_scripts_selected 	= ! empty( $sd_options['sd_scripts_selected'] ) ? json_decode( $sd_options['sd_scripts_selected'] ) : '';
                    $sd_styles_selected 	= ! empty( $sd_options['sd_styles_selected'] ) ? json_decode( $sd_options['sd_styles_selected'] ) : '';
                    $sd_urls_added			= ! empty( $sd_options['sd_urls_added'] ) ? json_decode( $sd_options['sd_urls_added'] ) : '';

                    $sc_sel_li = '';
                    $st_sel_li = '';
					
							
					// Create items for scripts in dequeue list
                    if ( is_array( $sd_scripts_selected ) && ! empty( $sd_scripts_selected ) ) {
                        $sc_sel_li = '';
						$count = 0;
                        foreach( $sd_scripts_selected as $script ) {
					
							// Post list					
							$post_li = '';
							$posts = get_posts( array( 'posts_per_page' => -1 ));
							$postids = explode( ',', $script->postids );
							foreach( $posts as $post ) {
								$class = false;
								if ( ! empty( $postids ) && is_array( $postids ) ) {
									if ( in_array( $post->ID, $postids ) ) {
										$class = 'ex-selected';
									}
								}
								if ( ! empty( $post->post_title ) ) {
									$post_li .= sprintf( '<li data-postid="%1$s"%2$s>%3$s</li>', $post->ID, $class ? ' class="' . esc_attr( $class ) . '"' : '', esc_attr( $post->post_title ) );
								}
							}
							
							// Page list
							$page_li = '';						
							$pages = get_pages();
							$pageids = explode( ',', $script->pageids );
							foreach( $pages as $page ) {
								if ( ! empty( $pageids ) && is_array( $pageids ) ) {
									if ( in_array( $page->ID, $pageids ) ) {
										$class = 'ex-selected';
									}
									else {
										$class = false;
									}
								}
								if ( ! empty( $page->post_title ) ) {
									$page_li .= sprintf( '<li data-pageid="%1$s"%2$s>%3$s</li>', $page->ID, $class ? ' class="' . esc_attr( $class ) . '"' : '', esc_attr( $page->post_title ) );
								}
							}
							
                            $sc_sel_li .= sprintf( '<li data-handle="%1$s" data-pageids="%2$s" data-postids="%3$s"><a href="#" class="dq-item">%1$s</a><a href="#" title="%9$s" class="exclude-toggle"></a><div class="sd-tabber">
								<ul class="sd-tabs">
									<li><a class="sd-tab-active" href="#sd-sc-page-list-%4$s">%5$s</a></li>
									<li><a href="#sd-sc-post-list-%4$s">%6$s</a></li>
								</ul>
								<ul id="sd-sc-page-list-%4$s" class="sd-tabbed-content sd-submenu page-list first">%7$s</ul>
								<ul id="sd-sc-post-list-%4$s" class="sd-tabbed-content sd-submenu post-list">%8$s</ul>
							</div></li>', $script->handle, $script->pageids, $script->postids, $count, esc_attr__( 'Pages', 'sdequeuer' ), esc_attr__( 'Posts', 'sdequeuer' ), $page_li, $post_li, esc_attr__( 'Exclude pages or posts from dequeue', 'sdequeuer' ) );
							$count++;							
							
                        }
                    }

                    else {
                        $sc_sel_li = '<li class="no-script">' . esc_attr__( 'No scripts added to dequeue.', 'sdequeuer' ) . '</li>';
                    }
					
					// Create items for styles in dequeue list
                    if ( is_array( $sd_styles_selected ) && ! empty( $sd_styles_selected ) ) {
                        $st_sel_li = '';
						$count = 0;
                        foreach( $sd_styles_selected as $style ) {
					
							// Post list					
							$post_li = '';
							$posts = get_posts( array( 'posts_per_page' => -1 ));
							$postids = explode( ',', $style->postids );
							foreach( $posts as $post ) {
								$class = false;
								if ( ! empty( $postids ) && is_array( $postids ) ) {
									if ( in_array( $post->ID, $postids ) ) {
										$class = 'ex-selected';
									}
									else {
										$class = false;
									}
								}
								if ( ! empty( $post->post_title ) ) {
									$post_li .= sprintf( '<li data-postid="%1$s"%2$s>%3$s</li>', $post->ID, $class ? ' class="' . esc_attr( $class ) . '"' : '', esc_attr( $post->post_title ) );
								}
							}
							
							// Page list
							$page_li = '';						
							$pages = get_pages();
							$pageids = explode( ',', $style->pageids );
							foreach( $pages as $page ) {
								$class = false;
								if ( ! empty( $pageids ) && is_array( $pageids ) ) {
									if ( in_array( $page->ID, $pageids ) ) {
										$class = 'ex-selected';
									}
								}
								if ( ! empty( $page->post_title ) ) {
									$page_li .= sprintf( '<li data-pageid="%1$s"%2$s>%3$s</li>', $page->ID, $class ? ' class="' . esc_attr( $class ) . '"' : '', esc_attr( $page->post_title ) );
								}
							}
							
							$st_sel_li .= sprintf( '<li data-handle="%1$s" data-pageids="%2$s" data-postids="%3$s"><a href="#" class="dq-item">%1$s</a><a href="#" title="%9$s" class="exclude-toggle"></a><div class="sd-tabber">
								<ul class="sd-tabs">
									<li><a class="sd-tab-active" href="#sd-st-page-list-%4$s">%5$s</a></li>
									<li><a href="#sd-st-post-list-%4$s">%6$s</a></li>
								</ul>
								<ul id="sd-st-page-list-%4$s" class="sd-tabbed-content sd-submenu page-list first">%7$s</ul>
								<ul id="sd-st-post-list-%4$s" class="sd-tabbed-content sd-submenu post-list">%8$s</ul>
							</div></li>', $style->handle, $style->pageids, $style->postids, $count, esc_attr__( 'Pages', 'sdequeuer' ), esc_attr__( 'Posts', 'sdequeuer' ), $page_li, $post_li, esc_attr__( 'Exclude pages or posts from dequeue', 'sdequeuer' ) );							
						$count++;	
                        }
                    }

                    else {
                        $st_sel_li = '<li class="no-script">' . esc_attr__( 'No styles added to dequeue.', 'sdequeuer' ) . '</li>';
                    }


                    // Get default URLs on which scripts shall be searched

                    $url_arr = sd_get_urls();
                    $url_li = '';

                    if ( is_array( $sd_urls_added ) && ! empty( $sd_urls_added ) ) {
                        foreach( $sd_urls_added as $url ) {
                            $url_li .= '<li><span class="sd-url-text">' . esc_url( $url ) . '</span><span class="sd-close-btn"></span></li>';
                        }
                    }

                    else {
                        if ( ! empty( $url_arr ) && is_array( $url_arr ) ) {
                            foreach( $url_arr as $url ) {
                                $url_li .= '<li><span class="sd-url-text">' . esc_url( $url ) . '</span><span class="sd-close-btn"></span></li>';
                            }
                        }
                    }
					
                    ?>
                    <div class="sd-tabber">
                        <ul class="sd-tabs">
                            <li><a href="#sd_scripts" class="sd-tab-active" id="sd_scripts-tab"><?php echo esc_attr_x( 'Scripts', 'settings tab title', 'sdequeuer' ); ?></a></li>
                            <li><a href="#sd_styles" id="sd_styles-tab"><?php echo esc_attr_x( 'Styles', 'settings tab title', 'sdequeuer' ); ?></a></li>
                            <li><a href="#sd_general" id="sd_general-tab"><?php echo esc_attr_x( 'General', 'settings tab title', 'sdequeuer' ); ?></a></li>
                        </ul>
                        <div id="sd_scripts" class="sd-tabbed-content first">
                            <div class="sd-row">
                                <div class="sd-col col-66">
                                <?php echo '<div id="sc-progress-info" class="sd-progress-info">
            <span id="sc-loading-text" class="sd-loading-text">' . esc_html__( 'Searching for JavaScript files on following URLs. Please wait...', 'sdequeuer' ) . '</span>
            <span id="sd-sc-error" class="sd-error-text"><h4>' . esc_html__( 'No files to show', 'sdequeuer' ) . '</h4><p>' . esc_html__( 'Either all files are dequeued, or there are no JavaScipt files on front-end, or there was some error detecting the files on front end.', 'sdequeuer' ) . '</p></span>
            <span id="sc-loading-spinner" class="sd-loading-spinner"></span>
        </div>

        <div id="sc-file-table" class="file-table-wrap">
            <h3>' . esc_html__( 'Scripts detected on front end.', 'sdequeuer' ) . '<span id="script-detected-count" class="sd-count"></span><span class="sd-tooltip">?<span class="sd-tooltip-holder">' . esc_html__( 'Select scripts to add to dequeue list and then Save Changes.', 'sdequeuer' ) . '</span></span><a id="select-all-scripts" href="#" class="select-all-btn">' . esc_html__( 'Select all', 'sdequeuer' ) . '</a></h3>
            <div class="scripts-loader">
                <table id="sd-scripts-table" class="table-selectable">
                    <tr class="table-head">
                    <th>' . esc_html__( 'Handle', 'sdequeuer' ) . '</th>
                    <th>' . esc_html__( 'Source', 'sdequeuer' ) . '</th>
                    <th>' . esc_html__( 'Dependencies', 'sdequeuer' ) . '</th>
                    </tr>
                </table>
            </div>
        </div>';
        ?>
                                </div><!-- /.col-66 -->
                                <div class="sd-col col-33">
                                <?php echo '<div id="sc-dequeue-wrap" class="sd-portlet">
            <h3>' . esc_html__( 'Scripts added for dequeue', 'sdequeuer' ) . '<span id="script-dequeue-count" class="sd-count"></span>
            <span class="sd-tooltip">?<span class="sd-tooltip-holder">' . esc_html__( 'Select scripts to remove from dequeue list and then Save Changes', 'sdequeuer' ) . '</span></span>
            <a id="select-dq-scripts" href="#" class="select-all-btn">' . esc_html__( 'Remove all', 'sdequeuer' ) . '</a></h3>
            <ul id="sd-scripts-for-dequeue" class="scripts-view">' . $sc_sel_li . '</ul>
        </div>';

        echo '<div id="sc-dequeued-wrap" class="sd-portlet">
        <h3>' . esc_html__( 'Scripts successfully dequeued', 'sdequeuer' ) . '<span id="script-dequeued-count" class="sd-count"></span>
        <span class="sd-tooltip">?<span class="sd-tooltip-holder">' . esc_html__( 'The following scripts were dequeued successfully.', 'sdequeuer' ) . '</span></span></h3>
        <ul id="sd-scripts-dequeued" class="file-list list-success"></ul></div>';

        echo '<div id="sc-notdequeued-wrap" class="sd-portlet">
        <h3>' . esc_html__( 'Scripts not dequeued', 'sdequeuer' ) . '<span id="script-notdequeued-count" class="sd-count"></span>
        <span class="sd-tooltip">?<span class="sd-tooltip-holder">' . esc_html__( 'The following scripts were not dequeued because other scripts may be dependent on these files.', 'sdequeuer' ) . '</span></span></h3>
        <ul id="sd-scripts-not-dequeued" class="file-list list-error"></ul>
        </div>';
        ?>
                                </div><!-- /.col-33 -->
                            </div><!-- /.sd-row -->
                        </div><!-- /#sd_scripts -->
                        <div id="sd_styles" class="sd-tabbed-content">
                            <div class="sd-row">
                                <div class="sd-col col-66">
                                <?php echo '<div id="st-progress-info" class="sd-progress-info">
            <span id="st-loading-text" class="sd-loading-text">' . esc_html__( 'Searching for CSS files on following URLs. Please wait...', 'sdequeuer' ) . '</span>
            <span id="sd-st-error" class="sd-error-text"><h4>' . esc_html__( 'No files to show', 'sdequeuer' ) . '</h4><p>' . esc_html__( 'Either all files are dequeued, or there are no CSS files on front-end, or there was some error detecting the files on front end.', 'sdequeuer' ) . '</p></span>
            <span id="st-loading-spinner" class="sd-loading-spinner"></span>
        </div>

        <div id="st-file-table" class="file-table-wrap">
            <h3>' . esc_html__( 'CSS files detected on front end.', 'sdequeuer' ) . '<span id="style-detected-count" class="sd-count"></span><span class="sd-tooltip">?<span class="sd-tooltip-holder">' . esc_html__( 'Select stylesheets to add to dequeue list and then Save Changes.', 'sdequeuer' ) . '</span></span><a id="select-all-styles" href="#" class="select-all-btn">' . esc_html__( 'Select all', 'sdequeuer' ) . '</a></h3>
            <div class="scripts-loader">
                <table id="sd-styles-table" class="table-selectable">
                    <tr class="table-head">
                    <th>' . esc_html__( 'Handle', 'sdequeuer' ) . '</th>
                    <th>' . esc_html__( 'Source', 'sdequeuer' ) . '</th>
                    <th>' . esc_html__( 'Dependencies', 'sdequeuer' ) . '</th>
                    </tr>
                </table>
            </div>
        </div>';
        ?>
                                </div><!-- /.col-66 -->
                                <div class="sd-col col-33">
                                <?php echo '<div id="st-dequeue-wrap" class="sd-portlet">
            <h3>' . esc_html__( 'CSS added for dequeue', 'sdequeuer' ) . '<span id="style-dequeue-count" class="sd-count"></span>
            <span class="sd-tooltip">?<span class="sd-tooltip-holder">' . esc_html__( 'Select stylesheets to remove from dequeue list and then Save Changes', 'sdequeuer' ) . '</span></span>
            <a id="select-dq-styles" href="#" class="select-all-btn">' . esc_html__( 'Remove all', 'sdequeuer' ) . '</a></h3>
            <ul id="sd-styles-for-dequeue" class="scripts-view">' . $st_sel_li . '</ul>
        </div>';

        echo '<div id="st-dequeued-wrap" class="sd-portlet">
        <h3>' . esc_html__( 'CSS successfully dequeued', 'sdequeuer' ) . '<span id="style-dequeued-count" class="sd-count"></span>
        <span class="sd-tooltip">?<span class="sd-tooltip-holder">' . esc_html__( 'The following stylesheets were dequeued successfully.', 'sdequeuer' ) . '</span></span></h3>
        <ul id="sd-styles-dequeued" class="file-list list-success"></ul></div>';

        echo '<div id="st-notdequeued-wrap" class="sd-portlet">
        <h3>' . esc_html__( 'CSS not dequeued', 'sdequeuer' ) . '<span id="style-notdequeued-count" class="sd-count"></span>
        <span class="sd-tooltip">?<span class="sd-tooltip-holder">' . esc_html__( 'The following stylesheets were not dequeued because other CSS files may be dependent on these files.', 'sdequeuer' ) . '</span></span></h3>
        <ul id="sd-styles-not-dequeued" class="file-list list-error"></ul>
        </div>';
        ?>
                                </div><!-- /.col-33 -->
                            </div><!-- /.sd-row -->
                        </div><!-- /#sd_styles -->
                        <div id="sd_general" class="sd-tabbed-content">
                            <div class="sd-row">
                                <div class="sd-col col-50">
                                    <h4><?php esc_attr_e( 'Add URLs on which files shall be searched', 'sdequeuer' ); ?></h4>

                                    <input type="text" class="regular-text" id="sd_url_input" name="sd_url_input" value=""> <a id="sd_add_url" class="button"><?php esc_attr_e( 'Add URL', 'sdequeuer' ); ?></a>
                                    <p class="sd-url-error"><?php esc_attr_e( 'Please provide a valid URL', 'sdequeuer' ); ?></p>

                                    <p class="description"><?php esc_attr_e( 'URLs should be from same site on which this plugin is installed. For best performance, keep number of URLs limited to 5-10.', 'sdequeuer' ); ?></p>

                                    <ul id="sd-sortable-list"><?php echo wp_kses_post( $url_li ); ?></ul>
                                </div><!-- /.col-50 -->
                                <div class="sd-col col-50">
                                    <?php
                                    // Output Settings Sections
									$this->do_settings_sections( 'scripts-dequeuer' );
									?>
                                </div><!-- /.col-50 -->
                            </div><!-- /.sd-row -->
                        </div><!-- /#sd_general -->
                    </div><!-- /.sd-tabber -->
                </div><!-- /.wrap -->
				<?php
                submit_button('Save Changes');
                ?>
            </form>
        </div><!-- /.wrap -->
	<?php
	}

	// Register Plugin Settings
	function register_settings() {

		// add_settings_section( $id, $title, $callback, $page )
		add_settings_section(
			'sd-settings',
			'SD Settings',
			'',
			'scripts-dequeuer'
		);

		add_settings_field(
			'sd_force_dq_sc',
			'',
			array($this, 'sd_checkbox_cb'),
			'scripts-dequeuer',
			'sd-settings',
			array(
				'option_name' 	=> 'sd_force_dq_sc',
				'title'			=> __( 'Force dequeue Scripts', 'sdequeuer' ),
				'desc'			=> __( 'Force dequeue scripts by ignoring dependencies', 'sdequeuer' )
			)
		);

		add_settings_field(
			'sd_force_dq_st',
			'',
			array($this, 'sd_checkbox_cb'),
			'scripts-dequeuer',
			'sd-settings',
			array(
				'option_name' 	=> 'sd_force_dq_st',
				'title'			=> __( 'Force dequeue Styles', 'sdequeuer' ),
				'desc'			=> __( 'Force dequeue stylesheets by ignoring dependencies', 'sdequeuer' )
			)
		);

		add_settings_field(
			'sd_scripts_selected',
			'',
			array($this, 'sd_hidden_input_cb'),
			'scripts-dequeuer',
			'sd-settings',
			'sd_scripts_selected'
		);

		add_settings_field(
			'sd_scripts_dequeued',
			'',
			array($this, 'sd_hidden_input_cb'),
			'scripts-dequeuer',
			'sd-settings',
			'sd_scripts_dequeued'
		);

		add_settings_field(
			'sd_scripts_not_dequeued',
			'',
			array($this, 'sd_hidden_input_cb'),
			'scripts-dequeuer',
			'sd-settings',
			'sd_scripts_not_dequeued'
		);

		add_settings_field(
			'sd_styles_selected',
			'',
			array($this, 'sd_hidden_input_cb'),
			'scripts-dequeuer',
			'sd-settings',
			'sd_styles_selected'
		);

		add_settings_field(
			'sd_styles_dequeued',
			'',
			array($this, 'sd_hidden_input_cb'),
			'scripts-dequeuer',
			'sd-settings',
			'sd_styles_dequeued'
		);

		add_settings_field(
			'sd_styles_not_dequeued',
			'',
			array($this, 'sd_hidden_input_cb'),
			'scripts-dequeuer',
			'sd-settings',
			'sd_styles_not_dequeued'
		);

		add_settings_field(
			'sd_urls_added',
			'',
			array($this, 'sd_hidden_input_cb'),
			'scripts-dequeuer',
			'sd-settings',
			'sd_urls_added'
		);

		// register_setting( $option_group, $option_name, $sanitize_callback )
		register_setting( 'sdequeuer-settings-group', 'sdequeuer_options' );
	}


	function sd_checkbox_cb( $args ) {
		$sd_options = get_option( 'sdequeuer_options' );
		$value = isset( $sd_options[ $args['option_name'] ] ) ? $sd_options[ $args['option_name'] ] : false;

        $html  = '<h4>' . esc_attr( $args['title'] ) . '</h4>';
		$html  .= '<fieldset>';
        $html  .= sprintf( '<label for="sdequeuer_options[%s]">', $args['option_name'] );
        $html  .= sprintf( '<input type="checkbox" class="checkbox" id="sdequeuer_options[%1$s]" name="sdequeuer_options[%1$s]" value="1" %2$s />', $args['option_name'], checked( $value, 1, false ) );
        $html  .= sprintf( '%1$s</label>', esc_html( $args['desc'] ) );
        $html  .= '</fieldset>';
        echo $html;
	}

	function sd_hidden_input_cb( $option_name ) {
		$sd_options = get_option( 'sdequeuer_options' );
		$value = isset( $sd_options[ $option_name ] ) ? $sd_options[ $option_name ] : '';
		?>
		<input type='hidden' id='sdequeuer_options[<?php echo esc_attr( $option_name ); ?>]' name='sdequeuer_options[<?php echo $option_name; ?>]' value='<?php echo $value; ?>'>
		<?php
	}

	/**
	 * Customized version of do_settings_sections
	 *
	 * Calls $this->do_settings_fields
	 */
	function do_settings_sections( $page ) {
		global $wp_settings_sections, $wp_settings_fields;

		if ( ! isset( $wp_settings_sections[$page] ) )
			return;

		foreach ( (array) $wp_settings_sections[$page] as $section ) {
			if ( $section['callback'] )
				call_user_func( $section['callback'], $section );

			if ( ! isset( $wp_settings_fields ) || !isset( $wp_settings_fields[$page] ) || !isset( $wp_settings_fields[$page][$section['id']] ) )
				continue;
			echo '<div>';
			$this->do_settings_fields( $page, $section['id'] );
			echo '</div>';
		}
	}

	/**
	 * Customized version of do_settings_fields
	 *
	 * Removed table elements tr, td, etc.
	 */
	function do_settings_fields($page, $section) {
		global $wp_settings_fields;

		if ( ! isset( $wp_settings_fields[$page][$section] ) )
			return;

		foreach ( (array) $wp_settings_fields[$page][$section] as $field ) {
			$class = '';

			if ( ! empty( $field['args']['class'] ) ) {
				$class = ' class="' . esc_attr( $field['args']['class'] ) . '"';
			}

			if ( ! empty( $field['title'] ) ) {
			echo '<h4>' . $field['title'] . '</h4>';
			}
			call_user_func($field['callback'], $field['args']);
		}
	}

}

$scripts_dequeuer_settings = new Script_Dequeuer_Settings();
?>